package labthree;

import javax.vecmath.Point2d;
import javax.vecmath.Point3d;
import javax.vecmath.Vector3d;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 */
public class Projection {
    public static double ang_alpha = Math.PI / 4.0;
    public static double ang_theta = Math.PI / 4.0;
    public static double distance  = 100.0;
    
    public static Point3d projection_eye = null;
    public static Plane projection_plane = null;

    public static void init() {
        double x = distance * Math.cos(ang_theta) * Math.cos(ang_alpha);
        double y = distance * Math.cos(ang_theta) * Math.sin(ang_alpha);
        double z = distance * Math.sin(ang_theta);
        projection_eye = new Point3d(x, y, z);
        //projection_plane = new Plane(x, y, z, new Point3d(x * .1, y * .1, z * .1));
        projection_plane = new Plane(x, y, z, new Point3d(0, 0, 0));
    }
    
    private static Point3d transformToYZ(Point3d p) {
        double cs, sn;
        Point3d resy = p;

        // alpha
        Point3d res = new Point3d();
        cs = Math.cos(-ang_alpha);
        sn = Math.sin(-ang_alpha);
        res.x = cs * resy.x - sn * resy.y;
        res.y = sn * resy.x + cs * resy.y;
        res.z = resy.z;

        // theta
        resy = new Point3d();
        cs = Math.cos(ang_theta);
        sn = Math.sin(ang_theta);
        resy.x = cs * res.x + sn * res.z;
        resy.y = res.y;
        resy.z = -sn * res.x + cs * res.z;
        
        return resy;
    }

    public static Point2d go(Point3d p) throws IntersectException {
        Vector3d vec_center = new Vector3d(-projection_eye.x, -projection_eye.y, -projection_eye.z);
        Vector3d vec_point = new Vector3d(p.x - projection_eye.x, p.y - projection_eye.y, p.z - projection_eye.z);
        double scal_sign = vec_center.x * vec_point.x + vec_center.y * vec_point.y + vec_center.z * vec_point.z;
        if(scal_sign < 1e-8) throw new IntersectException();

        Line l = new Line(projection_eye, p);
        Point3d proj_point = projection_plane.intersect(l);
        Point3d tran_point = transformToYZ(proj_point);
        //System.err.println(p + " -> " + proj_point + " -> " + tran_point);
        return new Point2d(tran_point.y, tran_point.z);
    }
}
