package labthree;

import javax.swing.*;
import javax.swing.border.LineBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 */
public class Window extends JFrame {
    public static JCheckBox chk_bezier_spline = null;
    public static JCheckBox chk_my_spline = null;
    

    private void addComponentsToPane() {
        // add plot pane
        PlotPanel plotter = new PlotPanel();
        plotter.setSize(600, 600);
        plotter.setBorder(new LineBorder(Color.BLUE));
        
        // bottom panel with checkboxes
        JPanel bottom_panel = new JPanel();
        bottom_panel.setLayout(new BoxLayout(bottom_panel, BoxLayout.LINE_AXIS));
        
        chk_bezier_spline = new JCheckBox();
        chk_bezier_spline.setText("Чужой сплайн");
        chk_bezier_spline.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Window.this.repaint();
            }
        });
        bottom_panel.add(chk_bezier_spline);
        
        chk_my_spline = new JCheckBox();
        chk_my_spline.setText("Мой сплайн");
        chk_my_spline.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Window.this.repaint();
            }
        });
        bottom_panel.add(chk_my_spline);
        
        // some code
        Container pane = getContentPane();
        pane.add(plotter, BorderLayout.CENTER);
        pane.add(bottom_panel, BorderLayout.PAGE_END);
    }

    Window() {
        super();
        Projection.init();
        setTitle("лабтри");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setPreferredSize(new Dimension(600, 600));
        addComponentsToPane();
        pack();
        setVisible(true);
        KeyListener navigation_listener =  new KeyListener() {
            @Override
            public void keyTyped(KeyEvent e) {
                //System.err.println("Typed: " + e.getKeyCode());
            }

            @Override
            public void keyPressed(KeyEvent e) {
                //System.err.println("Pressed: " + e.getKeyCode());
                if(e.getKeyCode() == 39)
                    Projection.ang_alpha -= 0.01;
                else if(e.getKeyCode() == 37)
                    Projection.ang_alpha += 0.01;
                else if(e.getKeyCode() == 38)
                    Projection.ang_theta -= 0.01;
                else if(e.getKeyCode() == 40)
                    Projection.ang_theta += 0.01;
                else if(e.getKeyCode() == 33)
                    Projection.distance -= 10;
                else if(e.getKeyCode() == 34)
                    Projection.distance += 10;
                if(Projection.distance < 10) Projection.distance = 10;
                Projection.init();
                Window.this.repaint();
            }

            @Override
            public void keyReleased(KeyEvent e) {
                //System.err.println("Released: " + e.getKeyCode());
            }
        };
        chk_bezier_spline.addKeyListener(navigation_listener);
        chk_my_spline.addKeyListener(navigation_listener);
    }
}
